
; Point d'entree de l'explosion
; Faut bien commencer quelques part hein !
; Ici on prendra l'emplacement du click (cette fonction est appelée sur un click)
; Puis on va exploser la bulle 
REVERSE:
	ld	a,(xcoord)
	call	DIVIDE_A_BY_EIGHT
	ld	e, a
	ld	a,(ycoord)
	call	DIVIDE_A_BY_EIGHT
	ld	c, a
	
	ld	a,(xcoord)
	call	DIVIDE_A_BY_EIGHT
	ld	e, a
	ld	a,(ycoord)
	call	DIVIDE_A_BY_EIGHT
	ld	c, a
	call	FLIP
	

aller_en_haut:
	push	bc
	inc	c
	call	FLIP
	dec	c
	pop	bc
aller_en_bas:
	push	bc
	dec	c
	call	FLIP
	inc	c
	pop	bc
aller_a_droite:
	push	de
	inc	e
	call	FLIP
	dec	e
	pop	de
aller_a_gauche:
	push	de
	dec	e
	call	FLIP
	inc	e
	pop	de

	ret

; Tester si la case est valide
; Ecrire la couleur (dans b)
; e = x
; c = y
; b contient la couleur a ecrire
FLIP:
	; >>> Tester si on est en dehors du field
	push	af
	ld	a, e
	cp	0
	jp	m, invalide
	cp	12
	jp	p, invalide
	ld	a, c
	cp	0
	jp	m, invalide
	cp	8
	jp	p, invalide
	jp	valide

invalide:
	pop	af
	ret

valide:
	pop	af
	call	FIELD_GET
	cp	1
	jp	z, ecrire_2

ecrire_1:
	ld	a, 1
	call	FIELD_SET
	jp	fin_ecriture
ecrire_2:
	ld	a, 2	
	call	FIELD_SET
	jp	fin_ecriture

fin_ecriture:
	push	af
	push	bc
	push	de
	push	hl
	call	PRINT_FIELD
	pop	hl
	pop	de
	pop	bc
	pop	af

	ret


IS_WINNER_BLACK:

	ld	ix, field	; charger l'adresse de la map
	ld	b, 8
	ld	a, 7


iw_loop1:
	push	bc
	ld	e, 0
	ld	b, 12	
iw_loop2:
	push	bc
	ld	b, (ix)

	push	af
	push	bc
	push	de
	push	hl
	ld	c, a
	call	FIELD_GET
	cp	1
	jp	z, iw_return_false
	pop	hl
	pop	de
	pop	bc
	pop	af
	inc	ix	
	inc	e
	pop	bc
	djnz	iw_loop2

	dec	a
	
	pop	bc
	djnz	iw_loop1

	ld	a, 1
	ret

iw_return_false:
	
	pop	hl
	pop	de
	pop	bc
	pop	af
	pop	bc
	pop	bc
	ld	a, 0
	ret



IS_WINNER_WHITE:

	ld	ix, field	; charger l'adresse de la map
	ld	b, 8
	ld	a, 7


iww_loop1:
	push	bc
	ld	e, 0
	ld	b, 12	
iww_loop2:
	push	bc
	ld	b, (ix)

	push	af
	push	bc
	push	de
	push	hl
	ld	c, a
	call	FIELD_GET
	cp	2
	jp	z, iww_return_false
	pop	hl
	pop	de
	pop	bc
	pop	af
	inc	ix	
	inc	e
	pop	bc
	djnz	iww_loop2

	dec	a
	
	pop	bc
	djnz	iww_loop1

	ld	a, 1
	ret

iww_return_false:
	
	pop	hl
	pop	de
	pop	bc
	pop	af
	pop	bc
	pop	bc
	ld	a, 0
	ret

	

	

